{-# LANGUAGE OverloadedStrings #-}

module ISTEX where

import ISTEX.Client
import Network.HTTP.Client (newManager)
import Network.HTTP.Client.TLS (tlsManagerSettings)
import Servant.Client

import Data.Text (Text)

runIstexAPIClient :: ClientM (Documents) -> IO (Either ClientError Documents)
runIstexAPIClient cmd = do
  manager' <- newManager tlsManagerSettings
  runClientM cmd (mkClientEnv manager' $ BaseUrl Https "api.istex.fr" 443 "document")

getMetadataWith :: Text -> Maybe Int -> IO (Either ClientError Documents)
getMetadataWith q l = do
  runIstexAPIClient $
    search
    (Just "author,title,abstract,publicationDate,refBibs")
    l
    (Just q)
